/* Ce programme se contente de ramplacer dans l'EEPROM le codage des ROTORS qui maintenant
   simule les permutations filaires internes.

Compilateur v1.7.9 :                  PGM               RAM dynamique
Textes dans le programme :      4772 Octets (15%)      624 Octets (30%) */

#include <EEPROM.h>
//------------------- Déclaration des constante du programme ----------------
#define Version_logiciel "Contenu EEPROM du vendredidi 16 Fevrier 2024." //@@@@@@@@@@@@@@@@@
#define Debut_Decimal 712
// Adresse de fin des textes pour du listage en HEXADECIMAL

//----------------------- Déclaration des variables -------------------------

byte OCTET;
int I, PTR;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.


byte Rotors_et_Reflecteurs[312] = {
     //-------------------------- Rotor I en Direct --------------------------
     4,9,10,2,7,1,23,9,13,16,3,8,2,9,10,18,7,3,0,22,6,13,5,20,4,10,
     //-------------------------- Rotor I en Retour --------------------------
     20,21,22,3,22,24,25,8,13,16,17,19,16,23,24,4,17,6,0,18,23,13,17,19,16,10,

     //------------------------- Rotor II en Direct --------------------------
     0,8,1,7,14,3,11,13,15,18,1,22,10,6,24,13,0,15,7,20,21,3,9,24,16,5,
     //------------------------- Rotor II en Retour --------------------------
     0,8,13,25,21,17,11,4,23,18,19,25,2,6,10,5,0,15,12,20,13,2,16,11,23,19,

     //------------------------- Rotor III en Direct -------------------------
     1,2,3,4,5,6,22,8,9,10,13,10,13,0,10,15,18,5,14,7,16,17,24,21,18,15,
     //------------------------- Rotor III en Retour -------------------------
     19,25,4,24,11,23,12,22,8,21,10,20,9,0,11,18,8,17,5,16,2,16,21,13,16,13,

     //-------------------------- Rotor IV en Direct -------------------------
     4,17,12,18,11,20,3,19,16,7,10,23,5,20,9,22,23,14,1,13,16,8,6,15,24,2,
     //-------------------------- Rotor IV en Retour -------------------------
     7,24,20,18,22,12,13,6,3,23,10,4,11,3,14,15,19,21,9,25,16,8,2,17,10,6,

     //--------------------------- Rotor V en Direct -------------------------
     21,24,25,14,2,3,13,17,12,6,8,18,1,20,23,8,10,5,20,16,22,19,9,7,4,11,
     //--------------------------- Rotor V en Retour -------------------------
     16,1,22,8,19,17,24,6,23,10,15,3,6,25,7,20,4,12,18,13,14,5,21,18,9,2,

     //---------------------------- Réflecteur B -----------------------------
     25,18,21,8,17,19,12,4,16,24,14,7,15,11,13,9,5,2,6,26,3,23,22,10,1,20,
     
     //---------------------------- Réflecteur C -----------------------------
     6,22,16,10,9,1,15,25,5,4,18,26,24,23,7,3,20,11,21,17,19,2,14,13,8,12};

void setup() {
  Serial.begin(57600);
  Serial.println(); Serial.println(); Serial.println(Version_logiciel); Serial.println();
  //---------------------- Créer les cinq rotors en EEPROM ----------------------
  Serial.println(); Serial.println(F("Inscription des Rotors et des Reflecteurs."));
  PTR = 712 ; I = 0;
  while (PTR < 1024) {EEPROM.write(PTR, Rotors_et_Reflecteurs[I]); I++; PTR++;}
  //-----------------------------------------------------------------------------  
  Lister_EEPROM();}

void loop() {} // la boucle de base ne fait rien !
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE. */
  while ((PTR < 1024) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++;}
     Serial.println();}

void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++;}}
 
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC();}

void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}

void Affiche_octet_ECHANTILLON() {
  if (OCTET < 10) Serial.print('0'); Serial.print(OCTET);}
 
void Lister_OCTET() {
  OCTET = EEPROM.read(PTR);
  if (PTR < Debut_Decimal) {  
     if ((OCTET > 31) && (OCTET < 126)) {Serial.print(' '); Serial.print(char(OCTET));}
     else Serial.print("..");}
  else Affiche_octet_ECHANTILLON();
  Serial.print(' '); PTR++; }
  
  
