/* Ce programme a pour but de remplir l'EEPROM avec la codification des organes de la machine,
   et loger un maximum de textes "définitifs" du dialogue H/M.
   Quand ce programme aura été téléversé et activé, il servira pour les textes définitifs
   des démonstrateurs à partir de P06 inclus jusqu'au logiciel d'exploitation.
   
   NOTE : Placer des textes en EEPROM devient rentable dès que la chaine fait
          deux caractères.

Compilateur v1.7.9 :                  PGM               RAM dynamique
Textes dans le programme :      6476 Octets (21%)      1299 Octets (63%) */

#include <EEPROM.h>
//------------------- Déclaration des constante du programme ----------------
#define Version_logiciel "Contenu EEPROM du Lundi 11 mars 2024." //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define Debut_Decimal 712
// Adresse de fin des textes pour du listage en HEXADECIMAL

//----------------------- Déclaration des variables -------------------------

byte OCTET;
int I, PTR;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.


byte Rotors_et_Reflecteurs[312] = {
     5,11,13,6,12,7,4,17,22,26,14,20,15,23,25,8,24,21,19,16,1,9,2,18,3,10,
     21,23,25,7,1,4,6,16,22,26,2,5,3,11,13,20,8,24,19,12,18,9,14,17,15,10,
     1,10,4,11,19,9,18,21,24,2,12,8,23,20,13,3,17,7,26,14,16,25,6,22,15,5,
     1,10,16,3,26,23,18,12,6,2,4,11,15,20,25,21,17,7,6,14,8,24,13,9,22,19,
     2,4,6,8,10,12,3,16,18,20,24,22,26,14,25,5,9,23,7,1,11,13,21,19,17,15,
     20,1,7,2,16,3,19,4,17,5,21,6,22,14,26,8,25,9,24,10,23,12,18,11,15,13,
     5,19,15,22,16,26,10,1,25,17,21,9,18,8,24,12,14,6,20,7,11,4,3,13,23,2,
     8,26,23,22,1,18,20,14,12,7,21,16,24,17,3,5,10,13,2,19,11,4,25,15,9,6,
     22,26,2,18,7,9,20,25,21,16,19,4,14,8,12,24,1,23,13,10,17,15,6,5,3,11,
     17,3,25,12,24,23,5,14,6,20,26,15,19,13,22,10,21,4,11,7,9,1,18,16,8,2,
     25,18,21,8,17,19,12,4,16,24,14,7,15,11,13,9,5,2,6,26,3,23,22,10,1,20,
     6,22,16,10,9,1,15,25,5,4,18,26,24,23,7,3,20,11,21,17,19,2,14,13,8,12};

void setup() {
  Serial.begin(57600);
  Serial.println(); Serial.println(); Serial.println(Version_logiciel); Serial.println();
  TEXTE_a_inscrire_en_EEPROM.reserve(30); // 30 caractères sont très suffisants.
  //--------------------------------------------------------------------
  // Effacement d'une zone intermédiaire avec des $00.
  for (PTR = 668; PTR < (712); PTR++) EEPROM.write(PTR, 0);
  //--------------------------------------------------------------------
  Serial.println(F("Ecriture en EEPROM des textes :")); Serial.println();
  
  PTR = 0; // PTR pointe la première adresse en début d'EEPROM.
  TEXTE_a_inscrire_en_EEPROM = "Rapide.Lente.Menu des COMMANDES."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Une lettre -> "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "? ou , : Rappel des commandes."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " I ou i : Mode INITIALISATION."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " S ou s : SAUVEGARDER la configuration."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " R ou r : RESTITUER"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " M ou m : Morse sonore OUI / NON."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " V ou v : Vitesse du d"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(233)); PTR++; // caractère 'é'.
  TEXTE_a_inscrire_en_EEPROM = "bit du code Morse."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " T ou t : Mode TEXTE."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " L ou lLETTRES."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " C ou c : Affiche la CONFIGURATION."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " P ou p : Espace disponible sous la PILE."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " & ou 1 : Passer en Mode CRYPTAGE."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "GROUPE d'identificationde.de Droite "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "de Gauche du Centre Version du Orientation"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "ROTOREFLECTEUR d"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(233)); PTR++; // Caractère 'é'.
  EEPROM.write(PTR, 'j'); PTR++;
  EEPROM.write(PTR, char(224)); PTR++; // Caractère 'à'.
  TEXTE_a_inscrire_en_EEPROM = " utilis"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(233)); PTR++; // caractère 'é'.
  TEXTE_a_inscrire_en_EEPROM = "e. F ou f : Configurer les FICHES crois"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(233)); PTR++; // Caractère 'é'.
  TEXTE_a_inscrire_en_EEPROM = "es."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " E ou e : Avec R, F, ou G : ERREUR. "; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "Attention : LGR > MAX. Un seul Caract"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(232)); PTR++; // Caractère 'è'.
  TEXTE_a_inscrire_en_EEPROM = "re !invalide."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "] devient [ Passage au mode"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " Retour n"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, (char('º'))); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "IndexOption "; Ecrire_Texte_en_EEPROM();

//---------------------- Créer les cinq rotors en EEPROM ----------------------
  Serial.println(); Serial.println(F("Inscription des Rotors et des Reflecteurs."));
  PTR = 712 ; I = 0;
  while (PTR < 1024) {EEPROM.write(PTR, Rotors_et_Reflecteurs[I]); I++; PTR++;}
//-----------------------------------------------------------------------------  
  Lister_EEPROM();}

void loop() {} // la boucle de base ne fait rien !
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE. */
  while ((PTR < 1024) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++;}
     Serial.println();}

void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++;}}
 
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC();}

void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}

void Affiche_octet_ECHANTILLON() {
  if (OCTET < 10) Serial.print('0'); Serial.print(OCTET);}
 
void Lister_OCTET() {
  OCTET = EEPROM.read(PTR);
  if (PTR < Debut_Decimal) {  
     if ((OCTET > 31) && (OCTET < 126)) {Serial.print(' '); Serial.print(char(OCTET));}
     else Serial.print("..");}
  else Affiche_octet_ECHANTILLON();
  Serial.print(' '); PTR++; }
  
  
